<p>Pogledajmo sada malo detaljnije centralni procesor računala. Slika 1 prikazuje njegovu građu na vrlo visokoj razini apstrakcije.</p>

<figure class="mlFigure">
<img src="@#file#(mp.svg)" alt="Građa procesora"><br>
<figcaption><span class="mlFigKey">Slika 1.</span> Građa procesora</figcaption>
</figure>

<p>Procesor se sastoji od tri velike cjeline:</p>
<ol>
<li>skupa registara,</li>
<li>aritmetičko-logičke jedinice te</li>
<li>upravljačke jedinice.</li>
</ol>

<p>Skup registara sastoji se od jednog ili više registara. Slika 2 u nastavku prikazuje
   primjer gdje se skup registara sastoji od četiri 8-bitni registara, što odgovara procesoru
   koji ćemo analizirati kroz ovu seriju minilekcija. Registri su simbolički nazvani
   <code>r0</code>, <code>r1</code>, <code>r2</code> i <code>r3</code>.</p>

<figure class="mlFigure">
<img src="@#file#(mpsustav2.svg)" alt="Skup registara"><br>
<figcaption><span class="mlFigKey">Slika 2.</span> Skup registara</figcaption>
</figure>

<h3>Registri</h3>
<p>Svaki od registara procesoru omogućava da privremeno zapamti neki podatak ili međurezultat
   koji je nastao tijekom obrade podataka. Naime, uobičajen skup instrukcija kojima procesori
   raspolažu ne omogućava provođenje općenitih aritmetičkih i logičkih operacija izravno nad
   podatcima u memoriji računala već je iste najprije iz memorije potrebno podatkovnom
   sabirnicom prenijeti do procesora i pohraniti u jedan od registara, potom se aritmetičko
   logičke operacije provedu nad tim podatkom i rezultat se ponovno pohrani u neki od registara.
   Po potrebi, mogu se provesti i daljnje operacije, a jednom kad je konačan rezultat spreman,
   isti se iz registra preko podatkovne sabirnice šalje iz procesora i zapisuje natrag u
   memoriju.</p>

<p> U tom smislu, zgodno je na registre procesora gledati kao na lokalne varijable
   kojima procesor raspolaže. Uočite da su memorije današnjih računala ogromne. Tako primjerice
   nije neobično da računalo raspolaže s milijardama okteta podataka koji se čuvaju u memoriji
   računala. S druge strane, procesor uobičajeno raspolaže s vrlo malim brojem svojih "lokalnih"
   varijabli (registara). Prilikom obrade te velike količine podataka, iste je, malo po malo,
   iz memorije potrebno prenijeti do procesora i zapisati u registre, tamo obraditi i potom
   vratiti u memoriju.</p>

<p>Svi podatci u računalu zapisani su u binarno i čuvaju se kao nizovi bitova gdje svaki
   bit može poprimiti isključivo vrijednosti nula ili jedan. Stoga ćemo se morati upoznati
   s načinom na koji nenegativne cijele brojeve, općenite cijele brojeve, podatke poput
   tekstova i slično transformiramo u nizove bitova. Tu će od interesa biti binarni brojevni
   sustav, prirodni binarni kod, zapisivanje 2-komplementom, ASCII-kod i slični.
   Primjerice, ovisno o interpretaciji, binarne uzorke zapisane u registrima <code>r0</code>
   do <code>r3</code> tumačit ćemo kao nenegativne cijele brojeve 0, 40, 255 i 3, ili pak
   kao cijele brojeve 0, 40, -1 i 3, i slično.</p>

<h3>Aritmetičko-logička jedinica</h3>
<p>Aritmetičko-logička jedinica digitalni je sklop koji je u procesoru zadužen za obradu
   podataka. Aritmetičko-logička jedinica uobičajeno djeluje nad podatcima koji su zapisani
   u registrima i rezultat vraća ponovno u registre.</p>
<p>Primjeri aritmetičkih operacija su zbrajanje, oduzimanje, množenje, dijeljenje, 
   inkrement broja (uvećavanje za 1), dekrement broja (umanjivanje za 1), izračun
   broja suprotnog predznaka i slično.</p>
<p>Primjeri logičkih operacija su izračun operacija logičko-I, logičko-ILI, logičko-NE te
   logičko-isključivo-ILI. Ovdje često ubrajamo i provođenje operacija posmaka u lijevo i 
   desno, aritmetičkih posmaka te rotacija u oba smjera.</p>

<h3>Upravljačka jedinica</h3>
<p>Upravljačka jedinica koordinira rad svog sklopovlja u procesoru kao i dijela sklopovlja 
   izvan procesora. Zadaća upravljačke jedinice jest analizirati koju instrukciju procesor
   trenutno izvodi, i na temelju nje generirati sve relevantne upravljačke signale koji će
   osigurati da se zadana operacija provede (primjerice, da se rezultat obrade zapiše u
   zadani registar, da se promijeni adresa s koje će se dohvatiti sljedeća instrukcija jer
   je trenutna instrukcija bila instrukcija skoka i slično).</p>
<p>Sve ovo događa se u diskretnim vremenskim koracima pod djelovanjem signala takta. 
   Za dohvat i izvođenje svake od instrukcija, kod jednostavnih procesora potrebno je više
   generirati više impulsa signala takta. I kod modernih procesora situacija je slična, samo
   što se kod njih učinkovitost izvođenja poboljšava uporabom takozvanih cjevovoda, zahvaljujući
   kojima se može u određenim situacijama postići efekt kao da se na svaki impuls signala
   takta izvede po jedna instrukcija. Procesor koji ćemo analizirati u ovoj seriji minilekcija
   zahtijevat će 7 impulsa signala takta za dohvat i izvođenje svake od instrukcija.</p>

